import { SerializedDeclaration, SerializedNode, SerializedSourceFile, SerializedSymbol, SerializedType } from '@code-to-json/core';
import { RefFor } from '@code-to-json/utils';
import { FormattedDeclarationRef, FormattedNodeRef, FormattedSourceFileRef, FormattedSymbolRef, FormattedTypeRef, FormatterRefRegistry } from './types';
export interface QueueSink<S, T, D, N, SF> {
    handleType(ref: FormattedTypeRef, item: SerializedType): T;
    handleSymbol(ref: FormattedSymbolRef, item: SerializedSymbol): S;
    handleSourceFile(ref: FormattedSourceFileRef, item: SerializedSourceFile): SF;
    handleDeclaration(ref: FormattedDeclarationRef, item: SerializedDeclaration): D;
    handleNode(ref: FormattedNodeRef, item: SerializedNode): N;
}
export interface DrainOutput<S, T, D, N, SF> {
    symbols: {
        [k: string]: S;
    };
    types: {
        [k: string]: T;
    };
    sourceFiles: {
        [k: string]: SF;
    };
    declarations: {
        [k: string]: D;
    };
    nodes: {
        [k: string]: N;
    };
}
interface DataCollectorInputs {
    t: SerializedType;
    s: SerializedSymbol;
    f: SerializedSourceFile;
    d: SerializedDeclaration;
    n: SerializedNode;
}
export interface DataCollector {
    queue<K extends keyof DataCollectorInputs & keyof FormatterRefRegistry, E extends DataCollectorInputs[K]>(thing: E, refType: K): RefFor<FormatterRefRegistry, K> | undefined;
    drain<S, T, D, N, SF>(sink: Partial<QueueSink<S, T, D, N, SF>>): DrainOutput<S, T, D, N, SF>;
}
export declare function create(): DataCollector;
export {};
//# sourceMappingURL=data-collector.d.ts.map